	page	,132
	title	ultoa - convert binary unsigned long integer to ASCII string
;***
;ultoa.asm - convert binary unsigned long integer to ASCII string
;
;	Copyright (c) 1985-1992, Microsoft Corporation. All rights reserved.
;
;Purpose:
;	Converts long int to character string.	Uses code in xtoa.asm.
;
;*******************************************************************************


include version.inc
.xlist
include cmacros.inc
.list

page
;***
;char *_ultoa(val, buf, radix) - convert unsigned long to char string
;
;Purpose:
;	Converts an unsigned long int to a character string
;
;Entry:
;	int val - value to be converted
;	int buf - pointer to buffer in which to store result
;	int radix - base to convert result to
;
;Exit:
;	Fills in buffer pointed to by buf with the result.  Also returns
;	a pointer to this buffer.
;
;Uses:
;
;Exceptions:
;
;*******************************************************************************
;--------------------------------------------------------------------------
;
;	char *_ultoa(val,buf,radix)
;
;	convert binary number to ascii string
;
;--------------------------------------------------------------------------


sBegin	code
assumes cs,code
assumes ds,data

extrn	__cltoasub:near

cProc	_ultoa,<PUBLIC>,<di,si>

	parmD	lval
	parmDP	lbuf
	parmW	lradix

cBegin

	mov	bl,0		; unsigned conversion
	jmp	__cltoasub

cEnd	nogen

sEnd	code

	end
