/***
*vecctor.cxx - C++ constructor helpers
*
*	Copyright (c) 1991-1992, Microsoft Corporation.  All rights reserved.
*
*Purpose:
*
*	NOTE:  The helper routines produced by this source must have
*	special names (i.e., not the "normal" C++ naming scheme).  Thus,
*	the build process involves producing .asm files, sed scripts, etc.
*
*******************************************************************************/

#include <stddef.h>

//	tm	this model				::= __near | __far | __huge
//	cm	ctor call model 		::= __near | __far
//	ctm	ctor this model 		::= __near | __far
//	vcm	__vec_ctor call model	::= __near | __far
//	nelems_t #elements type		::= ptrdiff_t | long

void pascal vcm vec_ctor(void tm* this_, size_t size, nelems_t eltCount,
			 void (pascal cm* ctor)(void ctm* this_))
{
	while (--eltCount >= 0) {
		(*ctor)(this_);
		this_ = (char tm*)this_ + size;
	}
}
